/* ccgo: igs/conn.hh
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef IGS_CONN_HH
#define IGS_CONN_HH
#include <sigc++/object.h>
#include <sigc++/signal.h>
#include <glibmm.h>
#include <string>
namespace igs
{
	class Conn :
		virtual public SigC::Object
	{
		bool conn_ok;
		int to_child;
		int from_child;
		pid_t child_pid;
		SigC::Connection grab_line_connection;
		bool grab_line(Glib::IOCondition);
		bool read_buffer();
		bool reading_buffer;
		SigC::Connection time_up_connection;
		bool time_up();
		int idle_time;
		bool no_wait;
	protected:
		std::string line_buffer;
		virtual void process_line();
		virtual void conn_lost();
	public:
		Conn();
		virtual ~Conn();
		bool open_conn(const std::string &);
		void close_conn();
		operator bool ();
		void send_line(const std::string &);
// 		SigC::Signal0<void> conn_lost;
		void set_no_wait(bool);
	};
}
#endif // IGS_CONN_HH
