/* ccgo: igs/parser/kibitz.cc
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "kibitz.hh"
#include <sstream>
#include <regexx.hh>
#define atms(i, j) (rx.match[i].atom[j].str())

using namespace igs;
using namespace parser;

extern Kibitz parser_kibitz;
Kibitz parser_kibitz(& parser_kibitz);

Parser * Kibitz::id(Control * c) const
{
	if (c->get_num_cmd() != 11) return 0;
	Kibitz * k = new Kibitz(c);
	if (k->parse_head()) return k;
	delete k;
	return 0;
}

bool Kibitz::parse_head()
{
	regexx::Regexx rx;
	if (! rx.exec(control->get_cmd_dat(), "Kibitz (\\S+ \\[.+\\]): Game \\S+ vs \\S+ \\[(\\d+)\\]")) return false;
	who = atms(0, 0);
	game = -1;
	std::istringstream(atms(0, 1)) >> game;
	if (game < 0) return false;
	return true;
}

Kibitz::Kibitz(Parser * p) :
	Parser(p)
{
}

Kibitz::Kibitz(Control * c) :
	Parser(c)
{
}

Kibitz::~Kibitz()
{
}

bool Kibitz::process()
{
	regexx::Regexx rx;
	if (! rx.exec(control->get_line(), "11    (.+)")) return false;
	std::string w = who + ": " + atms(0, 0);
	control->message_kibitz(game, w);
	return true;
}
